require("defines")
debug_status = 1
require("utils")

--------------------------------------------------------------------------------------
function on_init()
	global.ticks = global.ticks or 0
	global.noCreatorYet = global.noCreatorYet or true
	global.players_mem = global.players_mem or {}
	global.no_force = global.no_force or 0
	global.nb_forces = global.nb_forces or 3
end

script.on_init( on_init )

--------------------------------------------------------------------------------------
function on_configuration_changed(data)
	if data.mod_changes ~= nil and data.mod_changes["MayTheForceBeWithYou"] ~= nil then
		debug( "update mod: MayTheForceBeWithYou" )
		
		on_init()
		
		local player
		for _, player in pairs(game.players) do
			init_player( player )
		end	
	end
end

script.on_configuration_changed(on_configuration_changed)

--------------------------------------------------------------------------------------
function on_player_created(event)
	debug( "player created" )
	local player = game.players[event.player_index]
	
	init_player(player)
end

script.on_event(defines.events.on_player_created, on_player_created )

--------------------------------------------------------------------------------------
function init_player(player)
	local player_mem = 
	{
		creator = false, -- only one creator per map, is admin and cannot be unpromote
		admin = false, -- to promote other players
		avatar = nil, -- avatar to fly on the map, managing things
		forces_per_page = 10,
		forces_page_cur = 1,
		forces_page_max = 1,
		players_per_page = 10,
		players_page_cur = 1,
		players_page_max = 1,
		n_force_sel = 0,
		name_force_sel = "",
		n_force_del = 0,
		name_force_del = "",
		n_force_del_tick = 0,
		n_force_ren = 0,
	}
	
	global.players_mem[player.index] = global.players_mem[player.index] or player_mem
	player_mem = global.players_mem[player.index]
	
	if global.noCreatorYet and player.connected then
		player_mem.creator = true
		player_mem.admin = true
		global.noCreatorYet = false
	end
	
	if player.gui.top.but_mtfbwy then player.gui.top.but_mtfbwy.destroy() end
	
	if player_mem.admin then
		player.gui.top.add({type = "button", name = "but_mtfbwy", style = "mtfbwy_main_button_style"})				
	end
end

--------------------------------------------------------------------------------------
function debug_forces_and_players()
	local i, force, player
	for i,force in pairs(game.forces) do
		debug( "force(", i, ")=", force.name )
	end
	for i,player in pairs(game.players) do
		debug( "player(", i, ")=", player.name, " admin=", global.players_mem[player.index].admin )
	end
end

--------------------------------------------------------------------------------------
function on_tick(event)
	if global.ticks <= 0 then
		global.ticks = 144
	else
		global.ticks = global.ticks - 1
	end
	
	if global.ticks == 123 then
		if global.noCreatorYet then
			-- in case of existing game, first player connected becomes creator/main admin
			local player
			for _, player in pairs(game.players) do
				init_player(player)
			end
		end
	elseif global.ticks == 89 then
		local player
		for _, player in pairs(game.players) do
			if player.connected then
				local player_mem = global.players_mem[player.index]
				if player_mem.n_force_del ~= 0 and player_mem.n_force_del_tick > game.tick then
					player_mem.n_force_del = 0
					update_window(player)
				end
			end
		end
	end
end

script.on_event(defines.events.on_tick, on_tick)

--------------------------------------------------------------------------------------
function on_gui_click(event)
	--debug( "player click: " .. event.player_index )
	local player = game.get_player(event.player_index)
	
	if event.element.name == "but_mtfbwy" then
		if player.gui.left.frame_mtfbwy then
			player.gui.left.frame_mtfbwy.destroy()
		else
			update_window(player)
		end
		
	elseif event.element.name == "but_mtfbwy_test" then
		
	elseif event.element.name == "but_forces_pagedown" then
		local player = game.get_player(event.player_index)		
		local player_mem = global.players_mem[player.index]
		
		player_mem.forces_page_cur = max( 1, player_mem.forces_page_cur - 1 )
		update_window(player)
		
	elseif event.element.name == "but_forces_pageup" then
		local player = game.get_player(event.player_index)		
		local player_mem = global.players_mem[player.index]
		
		player_mem.forces_page_cur = min( player_mem.forces_page_max, player_mem.forces_page_cur + 1 )
		update_window(player)

	elseif event.element.name == "but_forces_add" then
		global.no_force = global.no_force + 1
		local force = game.create_force( "Force #" .. global.no_force )
		update_all_windows()

	elseif string.sub(event.element.name,1,20) == "but_mtfbwy_force_nam" then
		local player = game.get_player(event.player_index)		
		local player_mem = global.players_mem[player.index]
		player_mem.n_force_sel = tonumber(string.sub(event.element.name,21))
		debug( "sel", player_mem.n_force_sel )

		update_window(player)

	elseif string.sub(event.element.name,1,20) == "but_mtfbwy_force_del" then
		local player = game.get_player(event.player_index)		
		local player_mem = global.players_mem[player.index]
		local n_force_del = tonumber(string.sub(event.element.name,21))
		debug( "del", n_force_del )
		
		if n_force_del > 3 then
			if player_mem.n_force_del == n_force_del then
				game.merge_forces( player_mem.name_force_del, game.forces.neutral.name )
				update_all_windows()
				player_mem.n_force_del = 0
			else
				player_mem.n_force_del = n_force_del
				player.print( "Press again to confirm !" )
				player_mem.n_force_del_tick = game.tick + 120
				update_window(player)
			end
		else
			player.print( "Cannot delete this default force !" )
		end	

		update_window(player)
	end
end

script.on_event(defines.events.on_gui_click, on_gui_click)

--------------------------------------------------------------------------------------
function find_force(n)
	local force, i
	i = 1
	for _, force in pairs(game.forces) do
		if i == n then 
			return( force)
		end
		i=i+1
	end
	return(nil)
end

--------------------------------------------------------------------------------------
function update_all_windows()
	local player
	for _, player in pairs(game.players) do
		if player.connected then
			update_window(player)
		end
	end
end

--------------------------------------------------------------------------------------
function update_window(player)
	local guif = player.gui.left.frame_mtfbwy
	local guif2, guif3, guif4, guif5, guif6
	local frame_mtfbwy_forces, but_forces_pagecur
	local player_mem = global.players_mem[player.index]
	
	if player.gui.left.frame_mtfbwy then
		player.gui.left.frame_mtfbwy.destroy()
	end
	
	guif = player.gui.left.add({type = "frame", name = "frame_mtfbwy", caption = "Forces & players", direction = "vertical", style = "mtfbwy_frame_style"})
	guif = guif.add({type = "flow", name = "flow_mtfbwy", direction = "vertical", style = "mtfbwy_flow_style"})
	
	guif2 = guif.add({type = "flow", name = "flow_mtfbwy_common", direction = "horizontal", style = "mtfbwy_flow_style"})
	guif2.add({type = "button", name = "but_mtfbwy_test", caption = "Test", style = "mtfbwy_button_style"})
	
	guif2 = guif.add({type = "flow", name = "flow_mtfbwy_main", direction = "horizontal", style = "mtfbwy_flow_style"})
	
	guif3 = guif2.add({type = "frame", name = "frame_mtfbwy_forces", caption = "Forces", direction = "vertical", style = "mtfbwy_frame_style"})
	guif4 = guif3.add({type = "flow", name = "flow_mtfbwy_force0", direction = "horizontal", style = "mtfbwy_flow_style"})
	guif4.add({type = "button", name = "but_forces_pagedown", caption = "<", style = "mtfbwy_button_style"})
	but_forces_pagecur = guif4.add({type = "button", name = "but_forces_pagecur", style = "mtfbwy_button_style"})
	guif4.add({type = "button", name = "but_forces_pageup", caption = ">", style = "mtfbwy_button_style"})
	guif4.add({type = "button", name = "but_forces_add", caption = "+", style = "mtfbwy_button_style"})
	
	guif4 = guif3.add({type = "flow", name = "flow_mtfbwy_main", direction = "vertical", style = "mtfbwy_flow_style"})
	local force, name, i
	i = 1
	for name, force in pairs(game.forces) do
		if i <= player_mem.forces_page_cur * player_mem.forces_per_page and i >= 1 + (player_mem.forces_page_cur-1) * player_mem.forces_per_page then
			guif5 = guif4.add({type = "flow", name = "flow_mtfbwy_force" .. i, direction = "horizontal", style = "mtfbwy_flow_style"})
			guif5.add({type = "button", name = "but_mtfbwy_force_del" .. i, caption = "X", style = "mtfbwy_button_style"})
			guif5.add({type = "button", name = "but_mtfbwy_force_ren" .. i, caption = "n", style = "mtfbwy_button_style"})
			guif6 = guif5.add({type = "button", name = "but_mtfbwy_force_nam" .. i, caption = name, style = "mtfbwy_button_style"})
			if player_mem.n_force_sel == i then 
				guif6.style.font_color = colors.green 
				player_mem.name_force_sel = name
			end
			if player_mem.n_force_del == i then 
				guif6.style.font_color = colors.red
				player_mem.name_force_del = name
			end
		end
		i=i+1
	end
	player_mem.nb_forces = i-1
	player_mem.forces_page_max = 1 + math.floor( (player_mem.nb_forces-1) / player_mem.forces_per_page )
	but_forces_pagecur.caption = player_mem.forces_page_cur .. "/" .. player_mem.forces_page_max
	guif3.caption = "Forces (" .. player_mem.name_force_sel .. ")"
	
	guif3 = guif2.add({type = "frame", name = "frame_mtfbwy_players", direction = "vertical", style = "mtfbwy_frame_style"})
	guif3.add({type = "button", name = "but_mtfbwy_player", caption = "Player", style = "mtfbwy_button_style"})
		
	return(guif)
end
