data:extend(
	{
		{
			type = "font",
			name = "mtfbwy_font",
			from = "default",
			border = false,
			size = 15
		},
		{
			type = "font",
			name = "mtfbwy_font_bold",
			from = "default-bold",
			border = false,
			size = 15
		},
	}
)

local default_gui = data.raw["gui-style"].default

local spacing_right = 2
local spacing_vertical = 1



default_gui.mtfbwy_frame_style = 
{
	type="frame_style",
	parent="frame_style",
	top_padding = 0,
	right_padding = 0,
	bottom_padding = 0,
	left_padding = 0,
    --minimal_width = 200,
}

default_gui.mtfbwy_flow_style = 
{
	type = "flow_style",
	
	top_padding = 0,
	bottom_padding = spacing_vertical,
	left_padding = 0,
	right_padding = 0,
	
	horizontal_spacing = spacing_right,
	vertical_spacing = 0,
	--max_on_row = 1,
	max_on_row = 0,
	resize_row_to_width = true,
	resize_to_row_height = false,
	
	graphical_set = { type = "none" },
}

default_gui.mtfbwy_label_style =
{
	type="label_style",
	parent="default",
	font="mtfbwy_font",
	align = "left",
	default_font_color={r=1, g=1, b=1},
	hovered_font_color={r=1, g=1, b=1},
	top_padding = 0,
	right_padding = 0,
	bottom_padding = 0,
	left_padding = 0,
}

default_gui.mtfbwy_button_style = 
{
	type="button_style",
	parent="default",
	font="mtfbwy_font_bold",
	align = "center",
	default_font_color={r=1, g=1, b=1},
	hovered_font_color={r=1, g=1, b=1},
	top_padding = 0,
	right_padding = spacing_right,
	bottom_padding = 0,
	left_padding = spacing_right,
	left_click_sound =
	{
		{
		  filename = "__core__/sound/gui-click.ogg",
		  volume = 1
		}
	},
}

function extract_monolith(xx, yy)
	return {
		type = "monolith",

		top_monolith_border = 0,
		right_monolith_border = 0,
		bottom_monolith_border = 0,
		left_monolith_border = 0,

		monolith_image = {
			filename = "__MayTheForceBeWithYou__/graphics/mtfbwy-gui.png",
			priority = "extra-high-no-scale",
			width = 36,
			height = 36,
			x = xx,
			y = yy,
		},
	}
end

default_gui.mtfbwy_main_button_style = 
{
    type = "button_style",
	parent="slot_button_style",

	scalable = false,

	top_padding = 0,
	right_padding = 0,
	bottom_padding = 0,
	left_padding = 0,

	width = 36,
	height = 36,

	default_graphical_set = extract_monolith(0,  0),
	hovered_graphical_set = extract_monolith(36,  0),
	clicked_graphical_set = extract_monolith(72,  0),
}

default_gui.mtfbwy_textfield_style =
{
    type = "textfield_style",
	--parent="default",
	font="mtfbwy_font_bold",
	align = "left",
    font_color = {},
	default_font_color={r=1, g=1, b=1},
	hovered_font_color={r=1, g=1, b=1},
    selection_background_color= {r=0.66, g=0.7, b=0.83},
	top_padding = 0,
	bottom_padding = 0,
	left_padding = 0,
	right_padding = spacing_right,
	minimal_width = 350,
	maximal_width = 350,
	graphical_set =
	{
		type = "composition",
		filename = "__core__/graphics/gui.png",
		priority = "extra-high-no-scale",
		corner_size = {3, 3},
		position = {16, 0}
	},
}    

