-- utils.lua by binbinhfr, v1.0.4

-- define debug_status to 0 or 1 in the control.lua, before statement require("utils")

colors = {
	white = {r = 1, g = 1, b = 1},
	black = {r = 0, g = 0, b = 0},
	darkgrey = {r = 0.25, g = 0.25, b = 0.25},
	grey = {r = 0.5, g = 0.5, b = 0.5},
	lightgrey = {r = 0.75, g = 0.75, b = 0.75},

	red = {r = 1, g = 0, b = 0},
	darkred = {r = 0.5, g = 0, b = 0},
	lightred = {r = 1, g = 0.3, b = 0.3},
	green = {r = 0, g = 1, b = 0},
	darkgreen = {r = 0, g = 0.5, b = 0},
	lightgreen = {r = 0.3, g = 1, b = 0.3},
	blue = {r = 0, g = 0, b = 1},
	darkblue = {r = 0, g = 0, b = 0.5},
	lightblue = {r = 0.3, g = 0.3, b = 1},

	orange = {r = 1, g = 0.55, b = 0.1},
	yellow = {r = 1, g = 1, b = 0},
	pink = {r = 1, g = 0, b = 1},
	purple = {r = 0.6, g = 0.1, b = 0.6},
	brown = {r = 0.6, g = 0.4, b = 0.1},
}

anticolors = {
	white = colors.black,
	black = colors.white,
	darkgrey = colors.white,
	grey = colors.black,
	lightgrey = colors.black,

	red = colors.white,
	darkred = colors.white,
	lightred = colors.black,
	green = colors.black,
	darkgreen = colors.white,
	lightgreen = colors.black,
	blue = colors.white,
	darkblue = colors.white,
	lightblue = colors.black,

	orange = colors.black,
	yellow = colors.black,
	pink = colors.white,
	purple = colors.white,
	brown = colors.white,
}

--------------------------------------------------------------------------------------
function debug_active(...)
	debug_mem = debug_mem or {}
	
	local s = ""
	local i, v
	
	for i, v in ipairs({...}) do
		-- if i > 1 then s = s .. "," end
		s = s .. tostring(v)
		--s = s .. v
	end
	
	if s == "CLEAR" then
		for _, player in pairs(game.players) do
			if player.connected then player.clear_console() end
		end
	end
	
	if game ~= nil and #game.players > 0 then
		if #debug_mem > 0 then
			for _, m in pairs( debug_mem ) do
				for _, player in pairs(game.players) do
					if player.connected then player.print(m) end
				end
			end
			
			debug_mem = {}
		end
		
		if s ~= nil then 
			for _, player in pairs(game.players) do
				if player.connected then player.print(s) end
			end
		end
	else
		table.insert( debug_mem, s )
	end
end

if debug_status and debug_status == 1 then debug = debug_active else debug = function() end end

--------------------------------------------------------------------------------------
function square_area( origin, radius )
	return {
		{x=origin.x - radius, y=origin.y - radius},
		{x=origin.x + radius, y=origin.y + radius}
	}
end

--------------------------------------------------------------------------------------
function distance( pos1, pos2 )
	local dx = pos2.x - pos1.x
	local dy = pos2.y - pos1.y
	return( math.sqrt(dx*dx+dy*dy) )
end

--------------------------------------------------------------------------------------
function pos_offset( pos, offset )
	return { x=pos.x + offset.x, y=pos.y + offset.y }
end

--------------------------------------------------------------------------------------
function min( val1, val2 )
	if val1 < val2 then
		return val1
	else
		return val2
	end
end

--------------------------------------------------------------------------------------
function max( val1, val2 )
	if val1 > val2 then
		return val1
	else
		return val2
	end
end

--------------------------------------------------------------------------------------
function iif( cond, val1, val2 )
	if cond then
		return val1
	else
		return val2
	end
end

------------------------------------------------------------------------------------
-- function is_dev()
	-- if #game.players > 1 then return(false) end
	-- if game.players[1].name == "BinbinHfr" then return(true) end
	-- return(false)
-- end

--------------------------------------------------------------------------------------
function dupli_proto( type, name1, name2, adaptMiningResult )
	if not data.raw[type][name1] then error( "type " .. type .. " " .. name1 .. " doesn't exist", 2 ) end
	local proto = table.deepcopy(data.raw[type][name1])
	proto.name = name2
	if adaptMiningResult then
		if proto.minable and proto.minable.result then proto.minable.result = name2	end
	end
	if proto.place_result then proto.place_result = name2 end
	if proto.result then proto.result = name2 end
	return(proto)
end
